package ${config.package}

class Endpoints(override val config: OAuthUtils.OAuthConfig) extends framework.service.api.Endpoints with RutTapir with RutUtilsCodec:
    type ApiEndpoint[I, O] = OAuthEndpoint[RequestMeta.OAuthRequestMeta, I, ProblemDetail, O]

<#list endpoints as endpoint>
    val ${endpoint.inputType?uncap_first}Endpoint = ApiEndpoint[${endpoint.inputType?cap_first}, VersionedResponse] =
    <#list endpoint.paths.paths>
        apiV1Endpoint
        .post
        <#items as segment>
        .in("${segment}")
        </#items>
        .in(jsonBody[${endpoint.inputType?cap_first}])
        .out(jsonBody[VersionedResponse])

    </#list>
</#list>